Wt: Wt::Auth::RegistrationModel Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Attributes
Wt::Auth::RegistrationModel Class Reference
Authentication module (Wt::Auth)

Model for implementing a registration view. More...

`#include <Wt/Auth/RegistrationModel>`

Inheritance diagram for Wt::Auth::RegistrationModel:
[legend]

List of all members.

## Public Types
enum | EmailPolicy { EmailDisabled, EmailOptional, EmailMandatory }
| Enumeration for an email policy. More...
enum | IdentityConfirmationMethod { ConfirmWithPassword, ConfirmWithEmail, ConfirmationNotPossible }
| Method for confirming to be an existing user. More...
## Public Member Functions
| RegistrationModel (const AuthService &baseAuth, AbstractUserDatabase &users, Login &login, WObject *parent=0)
| Constructor.
virtual void | reset ()
| Resets the model.
Login & | login ()
| Returns the login object.
void | setMinLoginNameLength (int chars)
| Configures a minimum length for a login name.
int | minLoginNameLength () const
| Returns the minimum length for a login name.
void | setEmailPolicy (EmailPolicy policy)
| Configures whether an email address needs to be entered.
EmailPolicy | emailPolicy () const
| Returns the email policy.
virtual bool | registerIdentified (const Identity &identity)
| Register a user authenticated by an identity provider.
User | existingUser () const
| Returns the existing user that needs to be confirmed.
virtual IdentityConfirmationMethod | confirmIsExistingUser () const
| Returns the method to be used to confirm to be an existing user.
virtual void | existingUserConfirmed ()
| Confirms that the user is indeed an existing user.
virtual WString | validateLoginName (const WString &userName) const
| Validates the login name.
virtual void | checkUserExists (const WString &userName)
| Verifies that a user with that name does not yet exist.
virtual User | doRegister ()
| Performs the registration process.
virtual bool | isVisible (Field field) const
| Returns whether a field is visible.
virtual bool | isReadOnly (Field field) const
| Returns whether a field is read only.
virtual bool | validateField (Field field)
| Validates a field.
virtual bool | isConfirmUserButtonVisible () const
| Returns whether an existing user needs to be confirmed.
virtual bool | isFederatedLoginVisible () const
| Returns whether federated login options can be shown.
## Static Public Attributes
static const Field | ChoosePasswordField = "choose-password"
| Choose Password field.
static const Field | RepeatPasswordField = "repeat-password"
| Repeat password field.
static const Field | EmailField = "email"
| Email field (if login name is not email)

## Detailed Description

Model for implementing a registration view.

This model implements the logic for the registration of a new user. It can deal with traditional username/password registration, or registration of pre-identified users using federated login.

The model exposes four fields:

- LoginNameField: the login name (used as an identity for the Identity::LoginName provider) -- this can be an email if the AuthService is configured to use email addresses as identity
- ChoosePasswordField: the password
- RepeatPasswordField: the password (repeated)
- EmailField: if an email address is to be asked (and is not used as identity).

The largest complexity is in the handling of third party identity providers, which is initiated with a call to registerIdentified().

When a user is re-identified with the same identity, then the model may require that the (original) user confirms this new identity. The model indicates that this button should be made visible with isConfirmUserButtonVisible(), the action to take is determined by confirmIsExistingUser(), and existingUserConfirmed() ends this process by merging the new identity into the existing user.

See also:
  RegistrationWidget

## Member Enumeration Documentation

enum Wt::Auth::RegistrationModel::EmailPolicy

Enumeration for an email policy.

Enumerator:

  EmailDisabled | The email address is not asked for.
  EmailOptional | A user may optionally provide an email address.
  EmailMandatory | A user must provide an email address.

enum Wt::Auth::RegistrationModel::IdentityConfirmationMethod

Method for confirming to be an existing user.

Enumerator:

  ConfirmWithPassword | Confirm using a password prompt.
  ConfirmWithEmail | Confirm by using an email procedure.
  ConfirmationNotPossible | Confirmation is not possible.

## Constructor & Destructor Documentation

Wt::Auth::RegistrationModel::RegistrationModel | ( | const AuthService & | baseAuth,
|  | AbstractUserDatabase & | users,
|  | Login & | login,
|  | WObject * | parent = `0`
| ) |  |

Constructor.

Creates a new registration model, using a basic authentication service and user database.

The `login` object is used to indicate that an existing user was re-identified, and thus the registration process may be aborted.

## Member Function Documentation

void Wt::Auth::RegistrationModel::checkUserExists | ( | const WString & | userName | ) | `[virtual]`

Verifies that a user with that name does not yet exist.

If a user with that name already exists, it may in fact be the same user that is trying to register again (perhaps using a different identification method). If possible, we allow the user to confirm his identity.

RegistrationModel::IdentityConfirmationMethod Wt::Auth::RegistrationModel::confirmIsExistingUser | ( |  | ) | const`[virtual]`

Returns the method to be used to confirm to be an existing user.

When the ConfirmExisting field is visible, this returns an appropriate method to use to let the user confirm that he is indeed the identified existing user.

The outcome of this method (if it is an online method, like a password prompt), if successful, should be indicated using existingUserConfirmed().

See also:
  existingUserConfirmed()

EmailPolicy Wt::Auth::RegistrationModel::emailPolicy | ( |  | ) | const

Returns the email policy.

See also:
  setEmailPolicy()

User Wt::Auth::RegistrationModel::existingUser | ( |  | ) | const

Returns the existing user that needs to be confirmed.

When a user wishes to register with an identity that corresponds to an existing user, he may be allowd to confirm that he is in fact this existing user.

See also:
  confirmIsExistingUser()

void Wt::Auth::RegistrationModel::existingUserConfirmed | ( |  | ) | `[virtual]`

Confirms that the user is indeed an existing user.

The new identity is added to this existing user (if applicable), and the user is logged in.

bool Wt::Auth::RegistrationModel::isConfirmUserButtonVisible | ( |  | ) | const`[virtual]`

Returns whether an existing user needs to be confirmed.

This returns whether the user is being identified as an existing user and he can confirm that he is in fact the same user.

bool Wt::Auth::RegistrationModel::isFederatedLoginVisible | ( |  | ) | const`[virtual]`

Returns whether federated login options can be shown.

This returns whether fields for federated login (such as OAuth) should be shown. These are typically buttons corresponding to identity providers.

The result of a federated authentication procedure should be indicated to registerIdentified().

bool Wt::Auth::RegistrationModel::isReadOnly | ( | Field | field | ) | const`[virtual]`

Returns whether a field is read only.

The default implementation returns the value set by setReadOnly()

Reimplemented from Wt::WFormModel.

bool Wt::Auth::RegistrationModel::isVisible | ( | Field | field | ) | const`[virtual]`

Returns whether a field is visible.

In some cases not all fields of the model need to be shown. This may depend on values input for certain fields, and thus change dynamically. You may specialize this method to indicate that a certain field should be invisible.

The default implementation returns the value set by setVisible().

Reimplemented from Wt::WFormModel.

int Wt::Auth::RegistrationModel::minLoginNameLength | ( |  | ) | const

Returns the minimum length for a login name.

See also:
  setMinLoginNameLength()

bool Wt::Auth::RegistrationModel::registerIdentified | ( | const Identity & | identity | ) | `[virtual]`

Register a user authenticated by an identity provider.

Using a 3rd party authentication service such as OAuth, a user may be identified which is not yet registered with the web application.

Then, you may still need to allow the user to complete registration, but because the user already is identified and authenticated, this simplifies the registration form, since fields related to authentication can be dropped.

Returns `true` if the given identity was already registered, and has been logged in.

void Wt::Auth::RegistrationModel::reset | ( |  | ) | `[virtual]`

Resets the model.

This resets the model to initial values, clearing any entered information (login name, password, pre-identified identity).

Reimplemented from Wt::WFormModel.

void Wt::Auth::RegistrationModel::setEmailPolicy | ( | EmailPolicy | policy | ) |

Configures whether an email address needs to be entered.

You may specify whether you want the user to enter an email address.

This has no effect when the IdentityPolicy is EmailAddressIdentity.

The default policy is:

- EmailOptional when email address verification is enabled
- EmailDisabled otherwise

void Wt::Auth::RegistrationModel::setMinLoginNameLength | ( | int | chars | ) |

Configures a minimum length for a login name.

The default value is 4.

bool Wt::Auth::RegistrationModel::validateField | ( | Field | field | ) | `[virtual]`

Validates a field.

The default implementation uses the validator configured for the field to validate the field contents, or if no validator has been configured assumes that the field is valid.

You will typically customize this method for more complex validation cases.

See also:
  validate(), validationResult()

Reimplemented from Wt::WFormModel.

WString Wt::Auth::RegistrationModel::validateLoginName | ( | const WString & | userName | ) | const`[virtual]`

Validates the login name.

This verifies that the login name is adequate (see also setMinLoginNameLength()).

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator